import { warn } from '@ace-util/core';
import { registerSubModules } from './register';
var DEV_MODULE_KEY = 'dev-modules';
/**
 * Register dev modules from localStorage
 */
export function useDevModules() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var loader, lifeCycles;
    if (args[0] && ('setOptions' in args[0])) {
        loader = args[0];
    }
    else {
        lifeCycles = args[0];
        loader = args[1];
    }
    var devModuleStr = localStorage.getItem(DEV_MODULE_KEY);
    var devModules = [];
    if (devModuleStr) {
        try {
            devModules = JSON.parse(devModuleStr);
        }
        catch (_a) {
            warn(process.env.NODE_ENV === 'production', "{DEV_MODULE_KEY} is not a valid JSON string");
        }
    }
    return registerSubModules(devModules, lifeCycles)(loader);
}
