"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDevModules = void 0;
var core_1 = require("@ace-util/core");
var register_1 = require("./register");
var DEV_MODULE_KEY = 'dev-modules';
/**
 * Register dev modules from localStorage
 */
function useDevModules() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var loader, lifeCycles;
    if (args[0] && ('setOptions' in args[0])) {
        loader = args[0];
    }
    else {
        lifeCycles = args[0];
        loader = args[1];
    }
    var devModuleStr = localStorage.getItem(DEV_MODULE_KEY);
    var devModules = [];
    if (devModuleStr) {
        try {
            devModules = JSON.parse(devModuleStr);
        }
        catch (_a) {
            (0, core_1.warn)(process.env.NODE_ENV === 'production', "{DEV_MODULE_KEY} is not a valid JSON string");
        }
    }
    return (0, register_1.registerSubModules)(devModules, lifeCycles)(loader);
}
exports.useDevModules = useDevModules;
